Index: /branches/network/src/lib/network/network_game_manager.cc
===================================================================
--- /branches/network/src/lib/network/network_game_manager.cc	(revision 6419)
+++ /branches/network/src/lib/network/network_game_manager.cc	(revision 6420)
@@ -734,6 +734,4 @@
   }
 
-  PNode::getNullParent()->debugNode( 0 );
-
   return true;
 }
Index: /branches/network/src/world_entities/power_ups/param_power_up.cc
===================================================================
--- /branches/network/src/world_entities/power_ups/param_power_up.cc	(revision 6419)
+++ /branches/network/src/world_entities/power_ups/param_power_up.cc	(revision 6420)
@@ -25,4 +25,5 @@
 #include "factory.h"
 #include "load_param.h"
+#include "network_game_manager.h"
 
 using namespace std;
@@ -119,3 +120,40 @@
 }
 
+int ParamPowerUp::writeBytes( const byte * data, int length, int sender )
+{
+  setRequestedSync( false );
+  setIsOutOfSync( false );
 
+  SYNCHELP_READ_BEGIN();
+
+  SYNCHELP_READ_FKT( PowerUp::writeState );
+
+  return SYNCHELP_READ_N;
+}
+
+
+
+int ParamPowerUp::readBytes( byte * data, int maxLength, int * reciever )
+{
+  if ( isOutOfSync() && !requestedSync() && this->getHostID()!=this->getOwner() )
+  {
+    (NetworkGameManager::getInstance())->sync( this->getUniqueID(), this->getOwner() );
+    setRequestedSync( true );
+  }
+
+  int rec = this->getRequestSync();
+  if ( rec > 0 )
+  {
+    *reciever = rec;
+
+    SYNCHELP_WRITE_BEGIN();
+
+    SYNCHELP_WRITE_FKT( PowerUp::readState );
+
+    return SYNCHELP_WRITE_N;
+  }
+
+  *reciever = 0;
+  return 0;
+}
+
Index: /branches/network/src/world_entities/power_ups/param_power_up.h
===================================================================
--- /branches/network/src/world_entities/power_ups/param_power_up.h	(revision 6419)
+++ /branches/network/src/world_entities/power_ups/param_power_up.h	(revision 6420)
@@ -30,4 +30,7 @@
   int getValue();
 
+  virtual int writeBytes(const byte* data, int length, int sender);
+  virtual int readBytes(byte* data, int maxLength, int * reciever );
+
 protected:
   virtual void respawn();
Index: /branches/network/src/world_entities/space_ships/space_ship.cc
===================================================================
--- /branches/network/src/world_entities/space_ships/space_ship.cc	(revision 6419)
+++ /branches/network/src/world_entities/space_ships/space_ship.cc	(revision 6420)
@@ -31,4 +31,6 @@
 #include "key_mapper.h"
 #include "event_handler.h"
+
+#include "network_game_manager.h"
 
 #include "power_ups/weapon_power_up.h"
@@ -516,2 +518,39 @@
   }
 }
+
+
+int SpaceShip::writeBytes( const byte * data, int length, int sender )
+{
+  setRequestedSync( false );
+  setIsOutOfSync( false );
+
+  SYNCHELP_READ_BEGIN();
+
+  SYNCHELP_READ_FKT( WorldEntity::writeState );
+
+  return SYNCHELP_READ_N;
+}
+
+int SpaceShip::readBytes( byte * data, int maxLength, int * reciever )
+{
+  if ( isOutOfSync() && !requestedSync() && this->getHostID()!=this->getOwner() )
+  {
+    (NetworkGameManager::getInstance())->sync( this->getUniqueID(), this->getOwner() );
+    setRequestedSync( true );
+  }
+
+  int rec = this->getRequestSync();
+  if ( rec > 0 )
+  {
+    *reciever = rec;
+
+    SYNCHELP_WRITE_BEGIN();
+
+    SYNCHELP_WRITE_FKT( WorldEntity::readState );
+
+    return SYNCHELP_WRITE_N;
+  }
+
+  *reciever = 0;
+  return 0;
+}
Index: /branches/network/src/world_entities/space_ships/space_ship.h
===================================================================
--- /branches/network/src/world_entities/space_ships/space_ship.h	(revision 6419)
+++ /branches/network/src/world_entities/space_ships/space_ship.h	(revision 6420)
@@ -44,4 +44,7 @@
     bool pickup(PowerUp* powerUp);
 
+    virtual int       writeBytes(const byte* data, int length, int sender);
+    virtual int       readBytes(byte* data, int maxLength, int * reciever);
+
 
   private:
Index: /branches/network/src/world_entities/terrain.cc
===================================================================
--- /branches/network/src/world_entities/terrain.cc	(revision 6419)
+++ /branches/network/src/world_entities/terrain.cc	(revision 6420)
@@ -327,6 +327,4 @@
   SYNCHELP_READ_FKT( WorldEntity::writeState );
 
-  PNode::getNullParent()->debugNode( 0 );
-
   return SYNCHELP_READ_N;
 }