Index: /code/trunk/src/libraries/core/ConfigFileManager.cc
===================================================================
--- /code/trunk/src/libraries/core/ConfigFileManager.cc	(revision 6421)
+++ /code/trunk/src/libraries/core/ConfigFileManager.cc	(revision 6422)
@@ -489,5 +489,5 @@
     ConfigFileManager::~ConfigFileManager()
     {
-        for(std::map<ConfigFileType, ConfigFile*>::const_iterator it = this->configFiles_.begin(); it != this->configFiles_.end(); )
+        for (std::map<ConfigFileType, ConfigFile*>::const_iterator it = this->configFiles_.begin(); it != this->configFiles_.end(); )
             delete (it++)->second;
     }
@@ -507,5 +507,5 @@
     void ConfigFileManager::load()
     {
-        for(std::map<ConfigFileType, ConfigFile*>::const_iterator it = this->configFiles_.begin(); it != this->configFiles_.end(); ++it)
+        for (std::map<ConfigFileType, ConfigFile*>::const_iterator it = this->configFiles_.begin(); it != this->configFiles_.end(); ++it)
             it->second->load();
     }
@@ -513,5 +513,5 @@
     void ConfigFileManager::save()
     {
-        for(std::map<ConfigFileType, ConfigFile*>::const_iterator it = this->configFiles_.begin(); it != this->configFiles_.end(); ++it)
+        for (std::map<ConfigFileType, ConfigFile*>::const_iterator it = this->configFiles_.begin(); it != this->configFiles_.end(); ++it)
             it->second->save();
     }
@@ -519,5 +519,5 @@
     void ConfigFileManager::clean(bool bCleanComments)
     {
-        for(std::map<ConfigFileType, ConfigFile*>::const_iterator it = this->configFiles_.begin(); it != this->configFiles_.end(); ++it)
+        for (std::map<ConfigFileType, ConfigFile*>::const_iterator it = this->configFiles_.begin(); it != this->configFiles_.end(); ++it)
             this->clean(it->first, bCleanComments);
     }
@@ -545,5 +545,5 @@
     void ConfigFileManager::updateConfigValues()
     {
-        for(std::map<ConfigFileType, ConfigFile*>::const_iterator it = this->configFiles_.begin(); it != this->configFiles_.end(); ++it)
+        for (std::map<ConfigFileType, ConfigFile*>::const_iterator it = this->configFiles_.begin(); it != this->configFiles_.end(); ++it)
             it->second->updateConfigValues();
     }
Index: /code/trunk/src/libraries/core/DynLibManager.cc
===================================================================
--- /code/trunk/src/libraries/core/DynLibManager.cc	(revision 6421)
+++ /code/trunk/src/libraries/core/DynLibManager.cc	(revision 6422)
@@ -75,5 +75,5 @@
     {
         // Unload & delete resources in turn
-        for( DynLibList::iterator it = mLibList.begin(); it != mLibList.end(); ++it )
+        for (DynLibList::iterator it = mLibList.begin(); it != mLibList.end(); ++it)
         {
             it->second->unload();
Index: /code/trunk/src/libraries/core/Game.cc
===================================================================
--- /code/trunk/src/libraries/core/Game.cc	(revision 6421)
+++ /code/trunk/src/libraries/core/Game.cc	(revision 6422)
@@ -445,8 +445,8 @@
         {
             int indentation = 0;
-            while(pos < str.size() && str[pos] == ' ')
+            while (pos < str.size() && str[pos] == ' ')
                 ++indentation, ++pos;
             startPos = pos;
-            while(pos < str.size() && str[pos] != ' ')
+            while (pos < str.size() && str[pos] != ' ')
                 ++pos;
             stateStrings.push_back(std::make_pair(str.substr(startPos, pos - startPos), indentation));
Index: /code/trunk/src/libraries/core/IOConsole.cc
===================================================================
--- /code/trunk/src/libraries/core/IOConsole.cc	(revision 6421)
+++ /code/trunk/src/libraries/core/IOConsole.cc	(revision 6422)
@@ -345,5 +345,5 @@
     /*static*/ void IOConsole::resetTerminalMode()
     {
-        if(IOConsole::singletonPtr_s && IOConsole::singletonPtr_s->originalTerminalSettings_)
+        if (IOConsole::singletonPtr_s && IOConsole::singletonPtr_s->originalTerminalSettings_)
         {
             tcsetattr(0, TCSANOW, IOConsole::singletonPtr_s->originalTerminalSettings_);
Index: /code/trunk/src/libraries/core/Loader.cc
===================================================================
--- /code/trunk/src/libraries/core/Loader.cc	(revision 6421)
+++ /code/trunk/src/libraries/core/Loader.cc	(revision 6422)
@@ -244,5 +244,5 @@
                     {
                         it2++;
-                        if(it->second && !(it2->second) && it2->first < pos)
+                        if (it->second && !(it2->second) && it2->first < pos)
                             it = ++it2;
                         else
@@ -307,13 +307,13 @@
                         unsigned int tempCounter = 1;
                         size_t tempPos = pos++;
-                        while(temp[++tempPos] == '=')
+                        while (temp[++tempPos] == '=')
                         {
                             tempCounter++;
                         }
-                        if(temp[tempPos] != '[')
+                        if (temp[tempPos] != '[')
                         {
                             tempCounter = 0;
                         }
-                        else if(tempCounter == 0)
+                        else if (tempCounter == 0)
                         {
                             tempCounter = 1;
@@ -329,13 +329,13 @@
                             unsigned int tempCounter = 1;
                             size_t tempPos = pos++;
-                            while(temp[++tempPos] == '=')
+                            while (temp[++tempPos] == '=')
                             {
                                 tempCounter++;
                             }
-                            if(temp[tempPos] != ']')
+                            if (temp[tempPos] != ']')
                             {
                                 tempCounter = 0;
                             }
-                            else if(tempCounter == 0)
+                            else if (tempCounter == 0)
                             {
                                 tempCounter = 1;
@@ -346,5 +346,5 @@
                     }
                     std::string equalSigns;
-                    for(unsigned int i = 0; i < equalSignCounter; i++)
+                    for (unsigned int i = 0; i < equalSignCounter; i++)
                     {
                         equalSigns += '=';
Index: /code/trunk/src/libraries/core/input/InputManager.cc
===================================================================
--- /code/trunk/src/libraries/core/input/InputManager.cc	(revision 6421)
+++ /code/trunk/src/libraries/core/input/InputManager.cc	(revision 6422)
@@ -404,5 +404,5 @@
                 {
                     // Get smallest possible priority between 1 and maxStateStackSize_s
-                    for(std::map<int, InputState*>::reverse_iterator rit = activeStates_.rbegin();
+                    for (std::map<int, InputState*>::reverse_iterator rit = activeStates_.rbegin();
                         rit != activeStates_.rend(); ++rit)
                     {
Index: /code/trunk/src/libraries/core/input/KeyBinder.cc
===================================================================
--- /code/trunk/src/libraries/core/input/KeyBinder.cc	(revision 6421)
+++ /code/trunk/src/libraries/core/input/KeyBinder.cc	(revision 6422)
@@ -291,16 +291,12 @@
         std::vector<std::string>& oldKeynames = this->allCommands_[button->bindingString_];
         std::vector<std::string>::iterator it = std::find(oldKeynames.begin(), oldKeynames.end(), stream.str());
-        if(it != oldKeynames.end())
-        {
+        if (it != oldKeynames.end())
             oldKeynames.erase(it);
-        }
 
         if (!command.empty())
         {
             std::vector<std::string>& keynames = this->allCommands_[command];
-            if( std::find(keynames.begin(), keynames.end(), stream.str()) == keynames.end())
-            {
+            if (std::find(keynames.begin(), keynames.end(), stream.str()) == keynames.end())
                 this->allCommands_[command].push_back(stream.str());
-            }
         }
      }
@@ -312,5 +308,5 @@
     const std::string& KeyBinder::getBinding(const std::string& commandName)
     {
-        if( this->allCommands_.find(commandName) != this->allCommands_.end())
+        if (this->allCommands_.find(commandName) != this->allCommands_.end())
         {
             std::vector<std::string>& keynames = this->allCommands_[commandName];
@@ -331,11 +327,9 @@
     const std::string& KeyBinder::getBinding(const std::string& commandName, unsigned int index)
     {
-        if( this->allCommands_.find(commandName) != this->allCommands_.end())
+        if (this->allCommands_.find(commandName) != this->allCommands_.end())
         {
             std::vector<std::string>& keynames = this->allCommands_[commandName];
-            if(index < keynames.size())
-            {
+            if (index < keynames.size())
                 return keynames[index];
-            }
 
             return BLANKSTRING;
@@ -353,5 +347,5 @@
     unsigned int KeyBinder::getNumberOfBindings(const std::string& commandName)
     {
-        if( this->allCommands_.find(commandName) != this->allCommands_.end())
+        if (this->allCommands_.find(commandName) != this->allCommands_.end())
         {
             std::vector<std::string>& keynames = this->allCommands_[commandName];
Index: /code/trunk/src/libraries/core/input/Keyboard.cc
===================================================================
--- /code/trunk/src/libraries/core/input/Keyboard.cc	(revision 6421)
+++ /code/trunk/src/libraries/core/input/Keyboard.cc	(revision 6422)
@@ -36,9 +36,9 @@
     {
         // update modifiers
-        if(arg.key == OIS::KC_RMENU    || arg.key == OIS::KC_LMENU)
+        if (arg.key == OIS::KC_RMENU    || arg.key == OIS::KC_LMENU)
             modifiers_ |= KeyboardModifier::Alt;   // alt key
-        if(arg.key == OIS::KC_RCONTROL || arg.key == OIS::KC_LCONTROL)
+        if (arg.key == OIS::KC_RCONTROL || arg.key == OIS::KC_LCONTROL)
             modifiers_ |= KeyboardModifier::Ctrl;  // ctrl key
-        if(arg.key == OIS::KC_RSHIFT   || arg.key == OIS::KC_LSHIFT)
+        if (arg.key == OIS::KC_RSHIFT   || arg.key == OIS::KC_LSHIFT)
             modifiers_ |= KeyboardModifier::Shift; // shift key
 
@@ -56,9 +56,9 @@
     {
         // update modifiers
-        if(arg.key == OIS::KC_RMENU    || arg.key == OIS::KC_LMENU)
+        if (arg.key == OIS::KC_RMENU    || arg.key == OIS::KC_LMENU)
             modifiers_ &= ~KeyboardModifier::Alt;   // alt key
-        if(arg.key == OIS::KC_RCONTROL || arg.key == OIS::KC_LCONTROL)
+        if (arg.key == OIS::KC_RCONTROL || arg.key == OIS::KC_LCONTROL)
             modifiers_ &= ~KeyboardModifier::Ctrl;  // ctrl key
-        if(arg.key == OIS::KC_RSHIFT   || arg.key == OIS::KC_LSHIFT)
+        if (arg.key == OIS::KC_RSHIFT   || arg.key == OIS::KC_LSHIFT)
             modifiers_ &= ~KeyboardModifier::Shift; // shift key
 